/**
  * jQuery Colour picker: A tiny colour picker with useful extra features
  *
  * Copyright:
  * Dean Attali, https://deanattali.com
  * Cory LaViska for A Beautiful Site, LLC: https://www.abeautifulsite.net/
  * David Griswold http://davidgriswoldhh.mtbos.org/ (allowing alpha colours)
  *
  * Version: 1.6
  *
  * Contribute: https://github.com/daattali/jquery-colourpicker
  *
  * @license: https://opensource.org/licenses/MIT
  */
!function(F){"function"==typeof define&&define.amd?define(["jquery"],F):"object"==typeof exports?module.exports=F(require("jquery")):F(jQuery)}(function(F){function e(F){var e=F.closest(".colourpicker");F.removeData("colourpicker-initialized").removeData("colourpicker-settings").removeProp("size").removeClass("colourpicker-input"),e.before(F).remove()}function r(F){var e=F.closest(".colourpicker"),r=e.find(".colourpicker-panel"),o=F.data("colourpicker-settings");!F.data("colourpicker-initialized")||F.prop("disabled")||e.hasClass("colourpicker-focus")||(a(),e.addClass("colourpicker-focus"),r.stop(!0,!0).fadeIn(o.showSpeed,function(){o.show&&o.show.call(F.get(0))}))}function a(){F(".colourpicker-focus").each(function(){var e=F(this),r=e.find(".colourpicker-input"),a=e.find(".colourpicker-panel"),o=r.data("colourpicker-settings");a.fadeOut(o.hideSpeed,function(){o.hide&&o.hide.call(r.get(0)),e.removeClass("colourpicker-focus")})})}function o(F,e,r){var a=F.closest(".colourpicker").find(".colourpicker-input"),o=a.data("colourpicker-settings"),i=F.find("[class$=-picker]"),t=F.offset().left,n=F.offset().top,s=Math.round(e.pageX-t),g=Math.round(e.pageY-n),c=r?o.animationSpeed:0;e.originalEvent.changedTouches&&(s=e.originalEvent.changedTouches[0].pageX-t,g=e.originalEvent.changedTouches[0].pageY-n),s<0&&(s=0),g<0&&(g=0),s>F.width()&&(s=F.width()),g>F.height()&&(g=F.height()),F.is(".colourpicker-grid")?i.stop(!0).animate({top:g+"px",left:s+"px"},c,o.animationEasing,function(){l(a,F)}):i.stop(!0).animate({top:g+"px"},c,o.animationEasing,function(){l(a,F)})}function l(F,e){function r(F,e){var r,a;return F.length&&e?(r=F.offset().left,a=F.offset().top,{x:r-e.offset().left+F.outerWidth()/2,y:a-e.offset().top+F.outerHeight()/2}):null}var a,o,l,i,n=F.closest(".colourpicker"),s=F.data("colourpicker-settings"),g=n.find(".colourpicker-grid"),d=n.find(".colourpicker-grid-inner"),E=n.find(".colourpicker-slider"),u=n.find(".colourpicker-alpha-slider"),p=n.find(".colourpicker-alpha-inner-slider"),B=g.find("[class$=-picker]"),h=E.find("[class$=-picker]"),y=u.find("[class$=-picker]"),k=r(B,g),f=r(h,E),w=r(y,u);if(e.is(".colourpicker-grid, .colourpicker-slider, .colourpicker-alpha-slider")&&(i=A(o=b({h:a=c(360-parseInt(f.y*(360/E.height()),10),0,360),s:c(Math.floor(k.x*(100/g.width())),0,100),b:c(100-Math.floor(k.y*(100/g.height())),0,100),a:l=!!s.allowAlpha&&c(1-w.y*(1/u.height()),0,1)})),d.css("backgroundColor",A(b({h:a,s:100,b:100,a:1}))),!1!==l)){var q="rgba("+o.r+","+o.g+","+o.b+",",x="linear-gradient("+q+"1) 0, "+q+"0) 100%)",M="progid:DXImageTransform.Microsoft.gradient( startColorstr=#FF"+i.substr(1,7)+", endColorstr=#00000000, GradientType=0 );";p.css("background",x),p.css("filter",M)}e.is(".cp-list-col")&&(o=C(i=e.data("cp-col")),n.find(".cp-list-col").removeClass("selected-col"),n.find('.cp-list-col[data-cp-col="'+i+'"]').addClass("selected-col").addClass(m(o)?"dark":"light")),F.data("colour",o);var N=F.data("return-format"),I=F.data("allow-alpha");switch(F.val(D(o,N,I,"hex")),s.showColour){case"text":F.css("color",""),F.css("background-color","");break;case"background":F.css("color","transparent"),F.css("background-color",D(o,"rgb"));break;default:F.css("color",m(o)?"#ddd":"#000"),F.css("background-color",D(o,"rgb"))}o||(o=v(F)),t(F,o,F.data("transparent"))}function i(F,e){var r,a,o,l,i=F.closest(".colourpicker"),s=F.data("colourpicker-settings"),g=i.find(".colourpicker-grid"),d=i.find(".colourpicker-grid-inner"),E=i.find(".colourpicker-slider"),u=i.find(".colourpicker-alpha-slider"),p=i.find(".colourpicker-alpha-inner-slider"),B=g.find("[class$=-picker]"),h=E.find("[class$=-picker]"),y=u.find("[class$=-picker]"),f=F.data("return-format"),w=F.data("allow-alpha"),q=n(F,C(F.val()));switch(q||(q=v(F)),w||(q.a=!1),w&&!1===q.a&&(q.a=1),e||F.val(D(q,f,w,"hex")),F.data("colour",q),l=A(q),o=k(q),s.showColour){case"text":F.css("color",""),F.css("background-color","");break;case"background":F.css("color","transparent"),F.css("background-color",D(q,"rgb"));break;default:F.css("color",m(q)?"#ddd":"#000"),F.css("background-color",D(q,"rgb"))}if("limited"==s.palette&&(i.find(".cp-list-col").removeClass("selected-col"),i.find('.cp-list-col[data-cp-col="'+l+'"]').addClass("selected-col").addClass(m(q)?"dark":"light")),r=c(Math.ceil(o.s/(100/g.width())),0,g.width()),a=c(g.height()-Math.ceil(o.b/(100/g.height())),0,g.height()),B.css({top:a+"px",left:r+"px"}),a=c(E.height()-o.h/(360/E.height()),0,E.height()),h.css("top",a+"px"),d.css("backgroundColor",A(b({h:o.h,s:100,b:100,a:1}))),!1!==q.a){var x="rgba("+q.r+","+q.g+","+q.b+",",M="linear-gradient("+x+"1) 0, "+x+"0) 100%)",N="progid:DXImageTransform.Microsoft.gradient( startColorstr=#FF"+l.substr(1,7)+", endColorstr=#00000000, GradientType=0 );";p.css("background",M),p.css("filter",N),a=c(u.height()-q.a/(1/u.height()),0,u.height()),y.css("top",a+"px")}F.data("colourpicker-initialized")&&t(F,q,F.data("transparent")),F.data("transparent")?(i.find(".colourpicker-istransparent").prop("checked",!0),i.addClass("istransparent"),F.data("colour","transparent")):(i.find(".colourpicker-istransparent").prop("checked",!1),i.removeClass("istransparent")),F.trigger("change").trigger("input")}function t(F,e,r){var a=F.data("colourpicker-settings"),o=F.data("colourpicker-lastChange"),l=F.data("colourpicker-lastTransparent"),i=e.r===o.r&&e.b===o.b&&e.g===o.g&&e.a===o.a;o&&i&&l===r||(F.data("colourpicker-lastChange",e),F.data("colourpicker-lastTransparent",r),a.change&&(a.changeDelay?(clearTimeout(F.data("colourpicker-changeTimeout")),F.data("colourpicker-changeTimeout",setTimeout(function(){a.change.call(F.get(0),e)},a.changeDelay))):a.change.call(F.get(0),e)),F.trigger("change").trigger("input"))}function n(e,r){if(!(r=h(r)))return!1;if("limited"!==e.data("palette-type"))return r;var a=A(r,8);return-1!==F.inArray(a,e.data("hex8-allowed"))&&r}F.colourpicker={defaults:{animationSpeed:50,animationEasing:"swing",change:null,changeDelay:0,hide:null,hideSpeed:100,show:null,showSpeed:100,showColour:"both",allowTransparent:!1,transparentText:"Transparent",palette:"square",allowedCols:["#000000FF","#333333FF","#4D4D4DFF","#666666FF","#7F7F7FFF","#999999FF","#B3B3B3FF","#E5E5E5FF","#FFFFFFFF","#27408BFF","#000080FF","#0000FFFF","#1E90FFFF","#63B8FFFF","#97FFFFFF","#00FFFFFF","#00868BFF","#008B45FF","#458B00FF","#008B00FF","#00FF00FF","#7FFF00FF","#54FF9FFF","#00FF7FFF","#7FFFD4FF","#8B4500FF","#8B0000FF","#FF0000FF","#FF6A6AFF","#FF7F00FF","#FFFF00FF","#FFF68FFF","#F4A460FF","#551A8BFF","#8B008BFF","#8B0A50FF","#9400D3FF","#FF00FFFF","#FF1493FF","#E066FFFF"],returnName:!1,allowAlpha:!1,closeOnClick:!1}},F.extend(F.fn,{colourpicker:function(o,l){switch(o){case"destroy":return F(this).each(function(){e(F(this))}),F(this);case"hide":return a(),F(this);case"settings":return void 0===l?F(this).data("colourpicker-settings"):(F(this).each(function(){var r=F(this).data("colourpicker-settings")||{};e(F(this)),F(this).colourpicker(F.extend(!0,r,l))}),F(this));case"show":return r(F(this).eq(0)),F(this);case"value":if(void 0===l){if(F(this).data("allow-transparent")&&F(this).data("transparent"))return"transparent";var t=F(this).data("allow-alpha");return D(F(this).data("colour"),F(this).data("return-format"),t,"hex")}return F(this).each(function(){F(this).val(l),i(F(this))}),F(this);default:return"create"!==o&&(l=o),F(this).each(function(){!function(e,r){var a=F('<div class="colourpicker" />'),o=F('<div class="colourpicker-input-container" />'),l=F('<div class="input-group" />'),t=F.colourpicker.defaults;if(e.data("colourpicker-initialized"))return;r=F.extend(!1,{},t,r),"string"===F.type(r.allowedCols)&&(r.allowedCols=r.allowedCols.split(" "));var n=r.allowAlpha;"limited"==r.palette&&(n=!1);if(a.addClass("palette-"+r.palette).toggleClass("colourpicker-with-alpha",n),e.data("allow-alpha",r.allowAlpha),e.data("palette-type",r.palette),e.prop("spellcheck",!1).addClass("colourpicker-input").data("colourpicker-initialized",!1).data("colourpicker-lastChange",!1).data("colourpicker-settings",r).prop("size",7).wrap(a).wrap(o),"square"==r.palette)e.after('<div class="colourpicker-panel"><div class="colourpicker-slider colourpicker-sprite"><div class="colourpicker-slider-picker"></div></div><div class="colourpicker-alpha-slider"><div class="colourpicker-alpha-inner-slider"></div><div class="colourpicker-slider-picker"></div></div><div class="colourpicker-grid"><div class="colourpicker-grid-inner colourpicker-sprite"><div class="colourpicker-grid-inner-2"></div></div><div class="colourpicker-picker"><div></div></div></div></div>');else if("limited"==r.palette){var s='<div class="colourpicker-list">',g=[];F.each(r.allowedCols,function(F,r){var a=C(r);e.data("allow-alpha",!0);var o=A(a,8);g.push(o);var l=A(a),i="";i=0===a.a?"background-color: transparent":"background-color: "+D(a,"rgb"),s+='<span class="cp-list-col-outer"><span class="cp-list-col" data-cp-col="'+l+'" style="'+i+'" + ></span></span>'}),e.data("hex8-allowed",g),e.after('<div class="colourpicker-panel">'+s+"</div>")}else console.log("colourpicker: invalid palette type ("+r.palette+")");r.allowTransparent?(e.wrap(l),e.after('<label class="input-group-addon"><input type="checkbox" class="colourpicker-istransparent"> <span class="colourpicker-transparent-text">'+r.transparentText+"</span></label>"),e.data("allow-transparent",!0)):e.data("allow-transparent",!1);"background"==r.showColour?e.attr("readonly","readonly"):e.removeAttr("readonly");r.returnName?e.data("return-format","name"):e.data("return-format","hex");e.closest(".colourpicker").find(".colourpicker-panel").on("selectstart",function(){return!1}).end(),i(e,!1),e.data("colourpicker-initialized",!0)}(F(this),l)}),F(this)}}});var s={"#00000000":"transparent","#FFFFFFFF":"white","#F0F8FFFF":"aliceblue","#FAEBD7FF":"antiquewhite","#FFEFDBFF":"antiquewhite1","#EEDFCCFF":"antiquewhite2","#CDC0B0FF":"antiquewhite3","#8B8378FF":"antiquewhite4","#7FFFD4FF":"aquamarine","#76EEC6FF":"aquamarine2","#458B74FF":"aquamarine4","#F0FFFFFF":"azure","#E0EEEEFF":"azure2","#C1CDCDFF":"azure3","#838B8BFF":"azure4","#F5F5DCFF":"beige","#FFE4C4FF":"bisque","#EED5B7FF":"bisque2","#CDB79EFF":"bisque3","#8B7D6BFF":"bisque4","#000000FF":"black","#FFEBCDFF":"blanchedalmond","#0000FFFF":"blue","#0000EEFF":"blue2","#8A2BE2FF":"blueviolet","#A52A2AFF":"brown","#FF4040FF":"brown1","#EE3B3BFF":"brown2","#CD3333FF":"brown3","#8B2323FF":"brown4","#DEB887FF":"burlywood","#FFD39BFF":"burlywood1","#EEC591FF":"burlywood2","#CDAA7DFF":"burlywood3","#8B7355FF":"burlywood4","#5F9EA0FF":"cadetblue","#98F5FFFF":"cadetblue1","#8EE5EEFF":"cadetblue2","#7AC5CDFF":"cadetblue3","#53868BFF":"cadetblue4","#7FFF00FF":"chartreuse","#76EE00FF":"chartreuse2","#66CD00FF":"chartreuse3","#458B00FF":"chartreuse4","#D2691EFF":"chocolate","#FF7F24FF":"chocolate1","#EE7621FF":"chocolate2","#CD661DFF":"chocolate3","#FF7F50FF":"coral","#FF7256FF":"coral1","#EE6A50FF":"coral2","#CD5B45FF":"coral3","#8B3E2FFF":"coral4","#6495EDFF":"cornflowerblue","#FFF8DCFF":"cornsilk","#EEE8CDFF":"cornsilk2","#CDC8B1FF":"cornsilk3","#8B8878FF":"cornsilk4","#00FFFFFF":"cyan","#00EEEEFF":"cyan2","#00CDCDFF":"cyan3","#00008BFF":"darkblue","#008B8BFF":"darkcyan","#B8860BFF":"darkgoldenrod","#FFB90FFF":"darkgoldenrod1","#EEAD0EFF":"darkgoldenrod2","#CD950CFF":"darkgoldenrod3","#8B6508FF":"darkgoldenrod4","#A9A9A9FF":"darkgray","#006400FF":"darkgreen","#BDB76BFF":"darkkhaki","#8B008BFF":"darkmagenta","#556B2FFF":"darkolivegreen","#CAFF70FF":"darkolivegreen1","#BCEE68FF":"darkolivegreen2","#A2CD5AFF":"darkolivegreen3","#6E8B3DFF":"darkolivegreen4","#FF8C00FF":"darkorange","#FF7F00FF":"darkorange1","#EE7600FF":"darkorange2","#CD6600FF":"darkorange3","#8B4500FF":"darkorange4","#9932CCFF":"darkorchid","#BF3EFFFF":"darkorchid1","#B23AEEFF":"darkorchid2","#9A32CDFF":"darkorchid3","#68228BFF":"darkorchid4","#8B0000FF":"darkred","#E9967AFF":"darksalmon","#8FBC8FFF":"darkseagreen","#C1FFC1FF":"darkseagreen1","#B4EEB4FF":"darkseagreen2","#9BCD9BFF":"darkseagreen3","#698B69FF":"darkseagreen4","#483D8BFF":"darkslateblue","#2F4F4FFF":"darkslategray","#97FFFFFF":"darkslategray1","#8DEEEEFF":"darkslategray2","#79CDCDFF":"darkslategray3","#528B8BFF":"darkslategray4","#00CED1FF":"darkturquoise","#9400D3FF":"darkviolet","#FF1493FF":"deeppink","#EE1289FF":"deeppink2","#CD1076FF":"deeppink3","#8B0A50FF":"deeppink4","#00BFFFFF":"deepskyblue","#00B2EEFF":"deepskyblue2","#009ACDFF":"deepskyblue3","#00688BFF":"deepskyblue4","#696969FF":"dimgray","#1E90FFFF":"dodgerblue","#1C86EEFF":"dodgerblue2","#1874CDFF":"dodgerblue3","#104E8BFF":"dodgerblue4","#B22222FF":"firebrick","#FF3030FF":"firebrick1","#EE2C2CFF":"firebrick2","#CD2626FF":"firebrick3","#8B1A1AFF":"firebrick4","#FFFAF0FF":"floralwhite","#228B22FF":"forestgreen","#DCDCDCFF":"gainsboro","#F8F8FFFF":"ghostwhite","#FFD700FF":"gold","#EEC900FF":"gold2","#CDAD00FF":"gold3","#8B7500FF":"gold4","#DAA520FF":"goldenrod","#FFC125FF":"goldenrod1","#EEB422FF":"goldenrod2","#CD9B1DFF":"goldenrod3","#8B6914FF":"goldenrod4","#BEBEBEFF":"gray","#030303FF":"gray1","#050505FF":"gray2","#080808FF":"gray3","#0A0A0AFF":"gray4","#0D0D0DFF":"gray5","#0F0F0FFF":"gray6","#121212FF":"gray7","#141414FF":"gray8","#171717FF":"gray9","#1A1A1AFF":"gray10","#1C1C1CFF":"gray11","#1F1F1FFF":"gray12","#212121FF":"gray13","#242424FF":"gray14","#262626FF":"gray15","#292929FF":"gray16","#2B2B2BFF":"gray17","#2E2E2EFF":"gray18","#303030FF":"gray19","#333333FF":"gray20","#363636FF":"gray21","#383838FF":"gray22","#3B3B3BFF":"gray23","#3D3D3DFF":"gray24","#404040FF":"gray25","#424242FF":"gray26","#454545FF":"gray27","#474747FF":"gray28","#4A4A4AFF":"gray29","#4D4D4DFF":"gray30","#4F4F4FFF":"gray31","#525252FF":"gray32","#545454FF":"gray33","#575757FF":"gray34","#595959FF":"gray35","#5C5C5CFF":"gray36","#5E5E5EFF":"gray37","#616161FF":"gray38","#636363FF":"gray39","#666666FF":"gray40","#6B6B6BFF":"gray42","#6E6E6EFF":"gray43","#707070FF":"gray44","#737373FF":"gray45","#757575FF":"gray46","#787878FF":"gray47","#7A7A7AFF":"gray48","#7D7D7DFF":"gray49","#7F7F7FFF":"gray50","#828282FF":"gray51","#858585FF":"gray52","#878787FF":"gray53","#8A8A8AFF":"gray54","#8C8C8CFF":"gray55","#8F8F8FFF":"gray56","#919191FF":"gray57","#949494FF":"gray58","#969696FF":"gray59","#999999FF":"gray60","#9C9C9CFF":"gray61","#9E9E9EFF":"gray62","#A1A1A1FF":"gray63","#A3A3A3FF":"gray64","#A6A6A6FF":"gray65","#A8A8A8FF":"gray66","#ABABABFF":"gray67","#ADADADFF":"gray68","#B0B0B0FF":"gray69","#B3B3B3FF":"gray70","#B5B5B5FF":"gray71","#B8B8B8FF":"gray72","#BABABAFF":"gray73","#BDBDBDFF":"gray74","#BFBFBFFF":"gray75","#C2C2C2FF":"gray76","#C4C4C4FF":"gray77","#C7C7C7FF":"gray78","#C9C9C9FF":"gray79","#CCCCCCFF":"gray80","#CFCFCFFF":"gray81","#D1D1D1FF":"gray82","#D4D4D4FF":"gray83","#D6D6D6FF":"gray84","#D9D9D9FF":"gray85","#DBDBDBFF":"gray86","#DEDEDEFF":"gray87","#E0E0E0FF":"gray88","#E3E3E3FF":"gray89","#E5E5E5FF":"gray90","#E8E8E8FF":"gray91","#EBEBEBFF":"gray92","#EDEDEDFF":"gray93","#F0F0F0FF":"gray94","#F2F2F2FF":"gray95","#F7F7F7FF":"gray97","#FAFAFAFF":"gray98","#FCFCFCFF":"gray99","#00FF00FF":"green","#00EE00FF":"green2","#00CD00FF":"green3","#008B00FF":"green4","#ADFF2FFF":"greenyellow","#F0FFF0FF":"honeydew","#E0EEE0FF":"honeydew2","#C1CDC1FF":"honeydew3","#838B83FF":"honeydew4","#FF69B4FF":"hotpink","#FF6EB4FF":"hotpink1","#EE6AA7FF":"hotpink2","#CD6090FF":"hotpink3","#8B3A62FF":"hotpink4","#CD5C5CFF":"indianred","#FF6A6AFF":"indianred1","#EE6363FF":"indianred2","#CD5555FF":"indianred3","#8B3A3AFF":"indianred4","#FFFFF0FF":"ivory","#EEEEE0FF":"ivory2","#CDCDC1FF":"ivory3","#8B8B83FF":"ivory4","#F0E68CFF":"khaki","#FFF68FFF":"khaki1","#EEE685FF":"khaki2","#CDC673FF":"khaki3","#8B864EFF":"khaki4","#E6E6FAFF":"lavender","#FFF0F5FF":"lavenderblush","#EEE0E5FF":"lavenderblush2","#CDC1C5FF":"lavenderblush3","#8B8386FF":"lavenderblush4","#7CFC00FF":"lawngreen","#FFFACDFF":"lemonchiffon","#EEE9BFFF":"lemonchiffon2","#CDC9A5FF":"lemonchiffon3","#8B8970FF":"lemonchiffon4","#ADD8E6FF":"lightblue","#BFEFFFFF":"lightblue1","#B2DFEEFF":"lightblue2","#9AC0CDFF":"lightblue3","#68838BFF":"lightblue4","#F08080FF":"lightcoral","#E0FFFFFF":"lightcyan","#D1EEEEFF":"lightcyan2","#B4CDCDFF":"lightcyan3","#7A8B8BFF":"lightcyan4","#EEDD82FF":"lightgoldenrod","#FFEC8BFF":"lightgoldenrod1","#EEDC82FF":"lightgoldenrod2","#CDBE70FF":"lightgoldenrod3","#8B814CFF":"lightgoldenrod4","#FAFAD2FF":"lightgoldenrodyellow","#D3D3D3FF":"lightgray","#90EE90FF":"lightgreen","#FFB6C1FF":"lightpink","#FFAEB9FF":"lightpink1","#EEA2ADFF":"lightpink2","#CD8C95FF":"lightpink3","#8B5F65FF":"lightpink4","#FFA07AFF":"lightsalmon","#EE9572FF":"lightsalmon2","#CD8162FF":"lightsalmon3","#8B5742FF":"lightsalmon4","#20B2AAFF":"lightseagreen","#87CEFAFF":"lightskyblue","#B0E2FFFF":"lightskyblue1","#A4D3EEFF":"lightskyblue2","#8DB6CDFF":"lightskyblue3","#607B8BFF":"lightskyblue4","#8470FFFF":"lightslateblue","#778899FF":"lightslategray","#B0C4DEFF":"lightsteelblue","#CAE1FFFF":"lightsteelblue1","#BCD2EEFF":"lightsteelblue2","#A2B5CDFF":"lightsteelblue3","#6E7B8BFF":"lightsteelblue4","#FFFFE0FF":"lightyellow","#EEEED1FF":"lightyellow2","#CDCDB4FF":"lightyellow3","#8B8B7AFF":"lightyellow4","#32CD32FF":"limegreen","#FAF0E6FF":"linen","#FF00FFFF":"magenta","#EE00EEFF":"magenta2","#CD00CDFF":"magenta3","#B03060FF":"maroon","#FF34B3FF":"maroon1","#EE30A7FF":"maroon2","#CD2990FF":"maroon3","#8B1C62FF":"maroon4","#66CDAAFF":"mediumaquamarine","#0000CDFF":"mediumblue","#BA55D3FF":"mediumorchid","#E066FFFF":"mediumorchid1","#D15FEEFF":"mediumorchid2","#B452CDFF":"mediumorchid3","#7A378BFF":"mediumorchid4","#9370DBFF":"mediumpurple","#AB82FFFF":"mediumpurple1","#9F79EEFF":"mediumpurple2","#8968CDFF":"mediumpurple3","#5D478BFF":"mediumpurple4","#3CB371FF":"mediumseagreen","#7B68EEFF":"mediumslateblue","#00FA9AFF":"mediumspringgreen","#48D1CCFF":"mediumturquoise","#C71585FF":"mediumvioletred","#191970FF":"midnightblue","#F5FFFAFF":"mintcream","#FFE4E1FF":"mistyrose","#EED5D2FF":"mistyrose2","#CDB7B5FF":"mistyrose3","#8B7D7BFF":"mistyrose4","#FFE4B5FF":"moccasin","#FFDEADFF":"navajowhite","#EECFA1FF":"navajowhite2","#CDB38BFF":"navajowhite3","#8B795EFF":"navajowhite4","#000080FF":"navy","#FDF5E6FF":"oldlace","#6B8E23FF":"olivedrab","#C0FF3EFF":"olivedrab1","#B3EE3AFF":"olivedrab2","#698B22FF":"olivedrab4","#FFA500FF":"orange","#EE9A00FF":"orange2","#CD8500FF":"orange3","#8B5A00FF":"orange4","#FF4500FF":"orangered","#EE4000FF":"orangered2","#CD3700FF":"orangered3","#8B2500FF":"orangered4","#DA70D6FF":"orchid","#FF83FAFF":"orchid1","#EE7AE9FF":"orchid2","#CD69C9FF":"orchid3","#8B4789FF":"orchid4","#EEE8AAFF":"palegoldenrod","#98FB98FF":"palegreen","#9AFF9AFF":"palegreen1","#7CCD7CFF":"palegreen3","#548B54FF":"palegreen4","#AFEEEEFF":"paleturquoise","#BBFFFFFF":"paleturquoise1","#AEEEEEFF":"paleturquoise2","#96CDCDFF":"paleturquoise3","#668B8BFF":"paleturquoise4","#DB7093FF":"palevioletred","#FF82ABFF":"palevioletred1","#EE799FFF":"palevioletred2","#CD6889FF":"palevioletred3","#8B475DFF":"palevioletred4","#FFEFD5FF":"papayawhip","#FFDAB9FF":"peachpuff","#EECBADFF":"peachpuff2","#CDAF95FF":"peachpuff3","#8B7765FF":"peachpuff4","#CD853FFF":"peru","#FFC0CBFF":"pink","#FFB5C5FF":"pink1","#EEA9B8FF":"pink2","#CD919EFF":"pink3","#8B636CFF":"pink4","#DDA0DDFF":"plum","#FFBBFFFF":"plum1","#EEAEEEFF":"plum2","#CD96CDFF":"plum3","#8B668BFF":"plum4","#B0E0E6FF":"powderblue","#A020F0FF":"purple","#9B30FFFF":"purple1","#912CEEFF":"purple2","#7D26CDFF":"purple3","#551A8BFF":"purple4","#FF0000FF":"red","#EE0000FF":"red2","#CD0000FF":"red3","#BC8F8FFF":"rosybrown","#FFC1C1FF":"rosybrown1","#EEB4B4FF":"rosybrown2","#CD9B9BFF":"rosybrown3","#8B6969FF":"rosybrown4","#4169E1FF":"royalblue","#4876FFFF":"royalblue1","#436EEEFF":"royalblue2","#3A5FCDFF":"royalblue3","#27408BFF":"royalblue4","#8B4513FF":"saddlebrown","#FA8072FF":"salmon","#FF8C69FF":"salmon1","#EE8262FF":"salmon2","#CD7054FF":"salmon3","#8B4C39FF":"salmon4","#F4A460FF":"sandybrown","#2E8B57FF":"seagreen","#54FF9FFF":"seagreen1","#4EEE94FF":"seagreen2","#43CD80FF":"seagreen3","#FFF5EEFF":"seashell","#EEE5DEFF":"seashell2","#CDC5BFFF":"seashell3","#8B8682FF":"seashell4","#A0522DFF":"sienna","#FF8247FF":"sienna1","#EE7942FF":"sienna2","#CD6839FF":"sienna3","#8B4726FF":"sienna4","#87CEEBFF":"skyblue","#87CEFFFF":"skyblue1","#7EC0EEFF":"skyblue2","#6CA6CDFF":"skyblue3","#4A708BFF":"skyblue4","#6A5ACDFF":"slateblue","#836FFFFF":"slateblue1","#7A67EEFF":"slateblue2","#6959CDFF":"slateblue3","#473C8BFF":"slateblue4","#708090FF":"slategray","#C6E2FFFF":"slategray1","#B9D3EEFF":"slategray2","#9FB6CDFF":"slategray3","#6C7B8BFF":"slategray4","#FFFAFAFF":"snow","#EEE9E9FF":"snow2","#CDC9C9FF":"snow3","#8B8989FF":"snow4","#00FF7FFF":"springgreen","#00EE76FF":"springgreen2","#00CD66FF":"springgreen3","#008B45FF":"springgreen4","#4682B4FF":"steelblue","#63B8FFFF":"steelblue1","#5CACEEFF":"steelblue2","#4F94CDFF":"steelblue3","#36648BFF":"steelblue4","#D2B48CFF":"tan","#FFA54FFF":"tan1","#EE9A49FF":"tan2","#8B5A2BFF":"tan4","#D8BFD8FF":"thistle","#FFE1FFFF":"thistle1","#EED2EEFF":"thistle2","#CDB5CDFF":"thistle3","#8B7B8BFF":"thistle4","#FF6347FF":"tomato","#EE5C42FF":"tomato2","#CD4F39FF":"tomato3","#8B3626FF":"tomato4","#40E0D0FF":"turquoise","#00F5FFFF":"turquoise1","#00E5EEFF":"turquoise2","#00C5CDFF":"turquoise3","#00868BFF":"turquoise4","#EE82EEFF":"violet","#D02090FF":"violetred","#FF3E96FF":"violetred1","#EE3A8CFF":"violetred2","#CD3278FF":"violetred3","#8B2252FF":"violetred4","#F5DEB3FF":"wheat","#FFE7BAFF":"wheat1","#EED8AEFF":"wheat2","#CDBA96FF":"wheat3","#8B7E66FF":"wheat4","#F5F5F5FF":"whitesmoke","#FFFF00FF":"yellow","#EEEE00FF":"yellow2","#CDCD00FF":"yellow3","#8B8B00FF":"yellow4","#9ACD32FF":"yellowgreen"},g={transparent:"#00000000",white:"#FFFFFFFF",aliceblue:"#F0F8FFFF",antiquewhite:"#FAEBD7FF",antiquewhite1:"#FFEFDBFF",antiquewhite2:"#EEDFCCFF",antiquewhite3:"#CDC0B0FF",antiquewhite4:"#8B8378FF",aquamarine:"#7FFFD4FF",aquamarine1:"#7FFFD4FF",aquamarine2:"#76EEC6FF",aquamarine3:"#66CDAAFF",aquamarine4:"#458B74FF",azure:"#F0FFFFFF",azure1:"#F0FFFFFF",azure2:"#E0EEEEFF",azure3:"#C1CDCDFF",azure4:"#838B8BFF",beige:"#F5F5DCFF",bisque:"#FFE4C4FF",bisque1:"#FFE4C4FF",bisque2:"#EED5B7FF",bisque3:"#CDB79EFF",bisque4:"#8B7D6BFF",black:"#000000FF",blanchedalmond:"#FFEBCDFF",blue:"#0000FFFF",blue1:"#0000FFFF",blue2:"#0000EEFF",blue3:"#0000CDFF",blue4:"#00008BFF",blueviolet:"#8A2BE2FF",brown:"#A52A2AFF",brown1:"#FF4040FF",brown2:"#EE3B3BFF",brown3:"#CD3333FF",brown4:"#8B2323FF",burlywood:"#DEB887FF",burlywood1:"#FFD39BFF",burlywood2:"#EEC591FF",burlywood3:"#CDAA7DFF",burlywood4:"#8B7355FF",cadetblue:"#5F9EA0FF",cadetblue1:"#98F5FFFF",cadetblue2:"#8EE5EEFF",cadetblue3:"#7AC5CDFF",cadetblue4:"#53868BFF",chartreuse:"#7FFF00FF",chartreuse1:"#7FFF00FF",chartreuse2:"#76EE00FF",chartreuse3:"#66CD00FF",chartreuse4:"#458B00FF",chocolate:"#D2691EFF",chocolate1:"#FF7F24FF",chocolate2:"#EE7621FF",chocolate3:"#CD661DFF",chocolate4:"#8B4513FF",coral:"#FF7F50FF",coral1:"#FF7256FF",coral2:"#EE6A50FF",coral3:"#CD5B45FF",coral4:"#8B3E2FFF",cornflowerblue:"#6495EDFF",cornsilk:"#FFF8DCFF",cornsilk1:"#FFF8DCFF",cornsilk2:"#EEE8CDFF",cornsilk3:"#CDC8B1FF",cornsilk4:"#8B8878FF",cyan:"#00FFFFFF",cyan1:"#00FFFFFF",cyan2:"#00EEEEFF",cyan3:"#00CDCDFF",cyan4:"#008B8BFF",darkblue:"#00008BFF",darkcyan:"#008B8BFF",darkgoldenrod:"#B8860BFF",darkgoldenrod1:"#FFB90FFF",darkgoldenrod2:"#EEAD0EFF",darkgoldenrod3:"#CD950CFF",darkgoldenrod4:"#8B6508FF",darkgray:"#A9A9A9FF",darkgreen:"#006400FF",darkgrey:"#A9A9A9FF",darkkhaki:"#BDB76BFF",darkmagenta:"#8B008BFF",darkolivegreen:"#556B2FFF",darkolivegreen1:"#CAFF70FF",darkolivegreen2:"#BCEE68FF",darkolivegreen3:"#A2CD5AFF",darkolivegreen4:"#6E8B3DFF",darkorange:"#FF8C00FF",darkorange1:"#FF7F00FF",darkorange2:"#EE7600FF",darkorange3:"#CD6600FF",darkorange4:"#8B4500FF",darkorchid:"#9932CCFF",darkorchid1:"#BF3EFFFF",darkorchid2:"#B23AEEFF",darkorchid3:"#9A32CDFF",darkorchid4:"#68228BFF",darkred:"#8B0000FF",darksalmon:"#E9967AFF",darkseagreen:"#8FBC8FFF",darkseagreen1:"#C1FFC1FF",darkseagreen2:"#B4EEB4FF",darkseagreen3:"#9BCD9BFF",darkseagreen4:"#698B69FF",darkslateblue:"#483D8BFF",darkslategray:"#2F4F4FFF",darkslategray1:"#97FFFFFF",darkslategray2:"#8DEEEEFF",darkslategray3:"#79CDCDFF",darkslategray4:"#528B8BFF",darkslategrey:"#2F4F4FFF",darkturquoise:"#00CED1FF",darkviolet:"#9400D3FF",deeppink:"#FF1493FF",deeppink1:"#FF1493FF",deeppink2:"#EE1289FF",deeppink3:"#CD1076FF",deeppink4:"#8B0A50FF",deepskyblue:"#00BFFFFF",deepskyblue1:"#00BFFFFF",deepskyblue2:"#00B2EEFF",deepskyblue3:"#009ACDFF",deepskyblue4:"#00688BFF",dimgray:"#696969FF",dimgrey:"#696969FF",dodgerblue:"#1E90FFFF",dodgerblue1:"#1E90FFFF",dodgerblue2:"#1C86EEFF",dodgerblue3:"#1874CDFF",dodgerblue4:"#104E8BFF",firebrick:"#B22222FF",firebrick1:"#FF3030FF",firebrick2:"#EE2C2CFF",firebrick3:"#CD2626FF",firebrick4:"#8B1A1AFF",floralwhite:"#FFFAF0FF",forestgreen:"#228B22FF",gainsboro:"#DCDCDCFF",ghostwhite:"#F8F8FFFF",gold:"#FFD700FF",gold1:"#FFD700FF",gold2:"#EEC900FF",gold3:"#CDAD00FF",gold4:"#8B7500FF",goldenrod:"#DAA520FF",goldenrod1:"#FFC125FF",goldenrod2:"#EEB422FF",goldenrod3:"#CD9B1DFF",goldenrod4:"#8B6914FF",gray:"#BEBEBEFF",gray0:"#000000FF",gray1:"#030303FF",gray2:"#050505FF",gray3:"#080808FF",gray4:"#0A0A0AFF",gray5:"#0D0D0DFF",gray6:"#0F0F0FFF",gray7:"#121212FF",gray8:"#141414FF",gray9:"#171717FF",gray10:"#1A1A1AFF",gray11:"#1C1C1CFF",gray12:"#1F1F1FFF",gray13:"#212121FF",gray14:"#242424FF",gray15:"#262626FF",gray16:"#292929FF",gray17:"#2B2B2BFF",gray18:"#2E2E2EFF",gray19:"#303030FF",gray20:"#333333FF",gray21:"#363636FF",gray22:"#383838FF",gray23:"#3B3B3BFF",gray24:"#3D3D3DFF",gray25:"#404040FF",gray26:"#424242FF",gray27:"#454545FF",gray28:"#474747FF",gray29:"#4A4A4AFF",gray30:"#4D4D4DFF",gray31:"#4F4F4FFF",gray32:"#525252FF",gray33:"#545454FF",gray34:"#575757FF",gray35:"#595959FF",gray36:"#5C5C5CFF",gray37:"#5E5E5EFF",gray38:"#616161FF",gray39:"#636363FF",gray40:"#666666FF",gray41:"#696969FF",gray42:"#6B6B6BFF",gray43:"#6E6E6EFF",gray44:"#707070FF",gray45:"#737373FF",gray46:"#757575FF",gray47:"#787878FF",gray48:"#7A7A7AFF",gray49:"#7D7D7DFF",gray50:"#7F7F7FFF",gray51:"#828282FF",gray52:"#858585FF",gray53:"#878787FF",gray54:"#8A8A8AFF",gray55:"#8C8C8CFF",gray56:"#8F8F8FFF",gray57:"#919191FF",gray58:"#949494FF",gray59:"#969696FF",gray60:"#999999FF",gray61:"#9C9C9CFF",gray62:"#9E9E9EFF",gray63:"#A1A1A1FF",gray64:"#A3A3A3FF",gray65:"#A6A6A6FF",gray66:"#A8A8A8FF",gray67:"#ABABABFF",gray68:"#ADADADFF",gray69:"#B0B0B0FF",gray70:"#B3B3B3FF",gray71:"#B5B5B5FF",gray72:"#B8B8B8FF",gray73:"#BABABAFF",gray74:"#BDBDBDFF",gray75:"#BFBFBFFF",gray76:"#C2C2C2FF",gray77:"#C4C4C4FF",gray78:"#C7C7C7FF",gray79:"#C9C9C9FF",gray80:"#CCCCCCFF",gray81:"#CFCFCFFF",gray82:"#D1D1D1FF",gray83:"#D4D4D4FF",gray84:"#D6D6D6FF",gray85:"#D9D9D9FF",gray86:"#DBDBDBFF",gray87:"#DEDEDEFF",gray88:"#E0E0E0FF",gray89:"#E3E3E3FF",gray90:"#E5E5E5FF",gray91:"#E8E8E8FF",gray92:"#EBEBEBFF",gray93:"#EDEDEDFF",gray94:"#F0F0F0FF",gray95:"#F2F2F2FF",gray96:"#F5F5F5FF",gray97:"#F7F7F7FF",gray98:"#FAFAFAFF",gray99:"#FCFCFCFF",gray100:"#FFFFFFFF",green:"#00FF00FF",green1:"#00FF00FF",green2:"#00EE00FF",green3:"#00CD00FF",green4:"#008B00FF",greenyellow:"#ADFF2FFF",grey:"#BEBEBEFF",grey0:"#000000FF",grey1:"#030303FF",grey2:"#050505FF",grey3:"#080808FF",grey4:"#0A0A0AFF",grey5:"#0D0D0DFF",grey6:"#0F0F0FFF",grey7:"#121212FF",grey8:"#141414FF",grey9:"#171717FF",grey10:"#1A1A1AFF",grey11:"#1C1C1CFF",grey12:"#1F1F1FFF",grey13:"#212121FF",grey14:"#242424FF",grey15:"#262626FF",grey16:"#292929FF",grey17:"#2B2B2BFF",grey18:"#2E2E2EFF",grey19:"#303030FF",grey20:"#333333FF",grey21:"#363636FF",grey22:"#383838FF",grey23:"#3B3B3BFF",grey24:"#3D3D3DFF",grey25:"#404040FF",grey26:"#424242FF",grey27:"#454545FF",grey28:"#474747FF",grey29:"#4A4A4AFF",grey30:"#4D4D4DFF",grey31:"#4F4F4FFF",grey32:"#525252FF",grey33:"#545454FF",grey34:"#575757FF",grey35:"#595959FF",grey36:"#5C5C5CFF",grey37:"#5E5E5EFF",grey38:"#616161FF",grey39:"#636363FF",grey40:"#666666FF",grey41:"#696969FF",grey42:"#6B6B6BFF",grey43:"#6E6E6EFF",grey44:"#707070FF",grey45:"#737373FF",grey46:"#757575FF",grey47:"#787878FF",grey48:"#7A7A7AFF",grey49:"#7D7D7DFF",grey50:"#7F7F7FFF",grey51:"#828282FF",grey52:"#858585FF",grey53:"#878787FF",grey54:"#8A8A8AFF",grey55:"#8C8C8CFF",grey56:"#8F8F8FFF",grey57:"#919191FF",grey58:"#949494FF",grey59:"#969696FF",grey60:"#999999FF",grey61:"#9C9C9CFF",grey62:"#9E9E9EFF",grey63:"#A1A1A1FF",grey64:"#A3A3A3FF",grey65:"#A6A6A6FF",grey66:"#A8A8A8FF",grey67:"#ABABABFF",grey68:"#ADADADFF",grey69:"#B0B0B0FF",grey70:"#B3B3B3FF",grey71:"#B5B5B5FF",grey72:"#B8B8B8FF",grey73:"#BABABAFF",grey74:"#BDBDBDFF",grey75:"#BFBFBFFF",grey76:"#C2C2C2FF",grey77:"#C4C4C4FF",grey78:"#C7C7C7FF",grey79:"#C9C9C9FF",grey80:"#CCCCCCFF",grey81:"#CFCFCFFF",grey82:"#D1D1D1FF",grey83:"#D4D4D4FF",grey84:"#D6D6D6FF",grey85:"#D9D9D9FF",grey86:"#DBDBDBFF",grey87:"#DEDEDEFF",grey88:"#E0E0E0FF",grey89:"#E3E3E3FF",grey90:"#E5E5E5FF",grey91:"#E8E8E8FF",grey92:"#EBEBEBFF",grey93:"#EDEDEDFF",grey94:"#F0F0F0FF",grey95:"#F2F2F2FF",grey96:"#F5F5F5FF",grey97:"#F7F7F7FF",grey98:"#FAFAFAFF",grey99:"#FCFCFCFF",grey100:"#FFFFFFFF",honeydew:"#F0FFF0FF",honeydew1:"#F0FFF0FF",honeydew2:"#E0EEE0FF",honeydew3:"#C1CDC1FF",honeydew4:"#838B83FF",hotpink:"#FF69B4FF",hotpink1:"#FF6EB4FF",hotpink2:"#EE6AA7FF",hotpink3:"#CD6090FF",hotpink4:"#8B3A62FF",indianred:"#CD5C5CFF",indianred1:"#FF6A6AFF",indianred2:"#EE6363FF",indianred3:"#CD5555FF",indianred4:"#8B3A3AFF",ivory:"#FFFFF0FF",ivory1:"#FFFFF0FF",ivory2:"#EEEEE0FF",ivory3:"#CDCDC1FF",ivory4:"#8B8B83FF",khaki:"#F0E68CFF",khaki1:"#FFF68FFF",khaki2:"#EEE685FF",khaki3:"#CDC673FF",khaki4:"#8B864EFF",lavender:"#E6E6FAFF",lavenderblush:"#FFF0F5FF",lavenderblush1:"#FFF0F5FF",lavenderblush2:"#EEE0E5FF",lavenderblush3:"#CDC1C5FF",lavenderblush4:"#8B8386FF",lawngreen:"#7CFC00FF",lemonchiffon:"#FFFACDFF",lemonchiffon1:"#FFFACDFF",lemonchiffon2:"#EEE9BFFF",lemonchiffon3:"#CDC9A5FF",lemonchiffon4:"#8B8970FF",lightblue:"#ADD8E6FF",lightblue1:"#BFEFFFFF",lightblue2:"#B2DFEEFF",lightblue3:"#9AC0CDFF",lightblue4:"#68838BFF",lightcoral:"#F08080FF",lightcyan:"#E0FFFFFF",lightcyan1:"#E0FFFFFF",lightcyan2:"#D1EEEEFF",lightcyan3:"#B4CDCDFF",lightcyan4:"#7A8B8BFF",lightgoldenrod:"#EEDD82FF",lightgoldenrod1:"#FFEC8BFF",lightgoldenrod2:"#EEDC82FF",lightgoldenrod3:"#CDBE70FF",lightgoldenrod4:"#8B814CFF",lightgoldenrodyellow:"#FAFAD2FF",lightgray:"#D3D3D3FF",lightgreen:"#90EE90FF",lightgrey:"#D3D3D3FF",lightpink:"#FFB6C1FF",lightpink1:"#FFAEB9FF",lightpink2:"#EEA2ADFF",lightpink3:"#CD8C95FF",lightpink4:"#8B5F65FF",lightsalmon:"#FFA07AFF",lightsalmon1:"#FFA07AFF",lightsalmon2:"#EE9572FF",lightsalmon3:"#CD8162FF",lightsalmon4:"#8B5742FF",lightseagreen:"#20B2AAFF",lightskyblue:"#87CEFAFF",lightskyblue1:"#B0E2FFFF",lightskyblue2:"#A4D3EEFF",lightskyblue3:"#8DB6CDFF",lightskyblue4:"#607B8BFF",lightslateblue:"#8470FFFF",lightslategray:"#778899FF",lightslategrey:"#778899FF",lightsteelblue:"#B0C4DEFF",lightsteelblue1:"#CAE1FFFF",lightsteelblue2:"#BCD2EEFF",lightsteelblue3:"#A2B5CDFF",lightsteelblue4:"#6E7B8BFF",lightyellow:"#FFFFE0FF",lightyellow1:"#FFFFE0FF",lightyellow2:"#EEEED1FF",lightyellow3:"#CDCDB4FF",lightyellow4:"#8B8B7AFF",limegreen:"#32CD32FF",linen:"#FAF0E6FF",magenta:"#FF00FFFF",magenta1:"#FF00FFFF",magenta2:"#EE00EEFF",magenta3:"#CD00CDFF",magenta4:"#8B008BFF",maroon:"#B03060FF",maroon1:"#FF34B3FF",maroon2:"#EE30A7FF",maroon3:"#CD2990FF",maroon4:"#8B1C62FF",mediumaquamarine:"#66CDAAFF",mediumblue:"#0000CDFF",mediumorchid:"#BA55D3FF",mediumorchid1:"#E066FFFF",mediumorchid2:"#D15FEEFF",mediumorchid3:"#B452CDFF",mediumorchid4:"#7A378BFF",mediumpurple:"#9370DBFF",mediumpurple1:"#AB82FFFF",mediumpurple2:"#9F79EEFF",mediumpurple3:"#8968CDFF",mediumpurple4:"#5D478BFF",mediumseagreen:"#3CB371FF",mediumslateblue:"#7B68EEFF",mediumspringgreen:"#00FA9AFF",mediumturquoise:"#48D1CCFF",mediumvioletred:"#C71585FF",midnightblue:"#191970FF",mintcream:"#F5FFFAFF",mistyrose:"#FFE4E1FF",mistyrose1:"#FFE4E1FF",mistyrose2:"#EED5D2FF",mistyrose3:"#CDB7B5FF",mistyrose4:"#8B7D7BFF",moccasin:"#FFE4B5FF",navajowhite:"#FFDEADFF",navajowhite1:"#FFDEADFF",navajowhite2:"#EECFA1FF",navajowhite3:"#CDB38BFF",navajowhite4:"#8B795EFF",navy:"#000080FF",navyblue:"#000080FF",oldlace:"#FDF5E6FF",olivedrab:"#6B8E23FF",olivedrab1:"#C0FF3EFF",olivedrab2:"#B3EE3AFF",olivedrab3:"#9ACD32FF",olivedrab4:"#698B22FF",orange:"#FFA500FF",orange1:"#FFA500FF",orange2:"#EE9A00FF",orange3:"#CD8500FF",orange4:"#8B5A00FF",orangered:"#FF4500FF",orangered1:"#FF4500FF",orangered2:"#EE4000FF",orangered3:"#CD3700FF",orangered4:"#8B2500FF",orchid:"#DA70D6FF",orchid1:"#FF83FAFF",orchid2:"#EE7AE9FF",orchid3:"#CD69C9FF",orchid4:"#8B4789FF",palegoldenrod:"#EEE8AAFF",palegreen:"#98FB98FF",palegreen1:"#9AFF9AFF",palegreen2:"#90EE90FF",palegreen3:"#7CCD7CFF",palegreen4:"#548B54FF",paleturquoise:"#AFEEEEFF",paleturquoise1:"#BBFFFFFF",paleturquoise2:"#AEEEEEFF",paleturquoise3:"#96CDCDFF",paleturquoise4:"#668B8BFF",palevioletred:"#DB7093FF",palevioletred1:"#FF82ABFF",palevioletred2:"#EE799FFF",palevioletred3:"#CD6889FF",palevioletred4:"#8B475DFF",papayawhip:"#FFEFD5FF",peachpuff:"#FFDAB9FF",peachpuff1:"#FFDAB9FF",peachpuff2:"#EECBADFF",peachpuff3:"#CDAF95FF",peachpuff4:"#8B7765FF",peru:"#CD853FFF",pink:"#FFC0CBFF",pink1:"#FFB5C5FF",pink2:"#EEA9B8FF",pink3:"#CD919EFF",pink4:"#8B636CFF",plum:"#DDA0DDFF",plum1:"#FFBBFFFF",plum2:"#EEAEEEFF",plum3:"#CD96CDFF",plum4:"#8B668BFF",powderblue:"#B0E0E6FF",purple:"#A020F0FF",purple1:"#9B30FFFF",purple2:"#912CEEFF",purple3:"#7D26CDFF",purple4:"#551A8BFF",red:"#FF0000FF",red1:"#FF0000FF",red2:"#EE0000FF",red3:"#CD0000FF",red4:"#8B0000FF",rosybrown:"#BC8F8FFF",rosybrown1:"#FFC1C1FF",rosybrown2:"#EEB4B4FF",rosybrown3:"#CD9B9BFF",rosybrown4:"#8B6969FF",royalblue:"#4169E1FF",royalblue1:"#4876FFFF",royalblue2:"#436EEEFF",royalblue3:"#3A5FCDFF",royalblue4:"#27408BFF",saddlebrown:"#8B4513FF",salmon:"#FA8072FF",salmon1:"#FF8C69FF",salmon2:"#EE8262FF",salmon3:"#CD7054FF",salmon4:"#8B4C39FF",sandybrown:"#F4A460FF",seagreen:"#2E8B57FF",seagreen1:"#54FF9FFF",seagreen2:"#4EEE94FF",seagreen3:"#43CD80FF",seagreen4:"#2E8B57FF",seashell:"#FFF5EEFF",seashell1:"#FFF5EEFF",seashell2:"#EEE5DEFF",seashell3:"#CDC5BFFF",seashell4:"#8B8682FF",sienna:"#A0522DFF",sienna1:"#FF8247FF",sienna2:"#EE7942FF",sienna3:"#CD6839FF",sienna4:"#8B4726FF",skyblue:"#87CEEBFF",skyblue1:"#87CEFFFF",skyblue2:"#7EC0EEFF",skyblue3:"#6CA6CDFF",skyblue4:"#4A708BFF",slateblue:"#6A5ACDFF",slateblue1:"#836FFFFF",slateblue2:"#7A67EEFF",slateblue3:"#6959CDFF",slateblue4:"#473C8BFF",slategray:"#708090FF",slategray1:"#C6E2FFFF",slategray2:"#B9D3EEFF",slategray3:"#9FB6CDFF",slategray4:"#6C7B8BFF",slategrey:"#708090FF",snow:"#FFFAFAFF",snow1:"#FFFAFAFF",snow2:"#EEE9E9FF",snow3:"#CDC9C9FF",snow4:"#8B8989FF",springgreen:"#00FF7FFF",springgreen1:"#00FF7FFF",springgreen2:"#00EE76FF",springgreen3:"#00CD66FF",springgreen4:"#008B45FF",steelblue:"#4682B4FF",steelblue1:"#63B8FFFF",steelblue2:"#5CACEEFF",steelblue3:"#4F94CDFF",steelblue4:"#36648BFF",tan:"#D2B48CFF",tan1:"#FFA54FFF",tan2:"#EE9A49FF",tan3:"#CD853FFF",tan4:"#8B5A2BFF",thistle:"#D8BFD8FF",thistle1:"#FFE1FFFF",thistle2:"#EED2EEFF",thistle3:"#CDB5CDFF",thistle4:"#8B7B8BFF",tomato:"#FF6347FF",tomato1:"#FF6347FF",tomato2:"#EE5C42FF",tomato3:"#CD4F39FF",tomato4:"#8B3626FF",turquoise:"#40E0D0FF",turquoise1:"#00F5FFFF",turquoise2:"#00E5EEFF",turquoise3:"#00C5CDFF",turquoise4:"#00868BFF",violet:"#EE82EEFF",violetred:"#D02090FF",violetred1:"#FF3E96FF",violetred2:"#EE3A8CFF",violetred3:"#CD3278FF",violetred4:"#8B2252FF",wheat:"#F5DEB3FF",wheat1:"#FFE7BAFF",wheat2:"#EED8AEFF",wheat3:"#CDBA96FF",wheat4:"#8B7E66FF",whitesmoke:"#F5F5F5FF",yellow:"#FFFF00FF",yellow1:"#FFFF00FF",yellow2:"#EEEE00FF",yellow3:"#CDCD00FF",yellow4:"#8B8B00FF",yellowgreen:"#9ACD32FF"};function c(F,e,r){return F<e&&(F=e),F>r&&(F=r),F}function d(F,e){return Math.round(F*Math.pow(10,e))/Math.pow(10,e)}var E,u,p,B=(u="[\\s|\\(]+("+(E="(?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?)")+")[,|\\s]+("+E+")[,|\\s]+("+E+")\\s*\\)?",p="[\\s|\\(]+("+E+")[,|\\s]+("+E+")[,|\\s]+("+E+")[,|\\s]+("+E+")\\s*\\)?",{rgb:new RegExp("rgb"+u),rgba:new RegExp("rgba"+p),hsl:new RegExp("hsl"+u),hsla:new RegExp("hsla"+p),hsv:new RegExp("hs[vb]"+u),hsva:new RegExp("hs[vb]a"+p),hex3:/^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,hex4:/^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,hex6:/^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,hex8:/^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/});function C(F){var e;return F.toLowerCase()in g?C(y(g[F.toLowerCase()])):(e=B.rgb.exec(F))?{r:c(parseInt(e[1]),0,255),g:c(parseInt(e[2]),0,255),b:c(parseInt(e[3]),0,255),a:!1}:(e=B.rgba.exec(F))?{r:c(parseInt(e[1]),0,255),g:c(parseInt(e[2]),0,255),b:c(parseInt(e[3]),0,255),a:c(parseFloat(e[4]),0,1)}:(e=B.hsl.exec(F))?f({h:c(parseFloat(e[1]),0,360),s:c(parseFloat(e[2]),0,100),l:c(parseFloat(e[3]),0,100),a:!1}):(e=B.hsla.exec(F))?f({h:c(parseFloat(e[1]),0,360),s:c(parseFloat(e[2]),0,100),l:c(parseFloat(e[3]),0,100),a:c(parseFloat(e[4]),0,1)}):(e=B.hsv.exec(F))?b({h:c(parseFloat(e[1]),0,360),s:c(parseFloat(e[2]),0,100),b:c(parseFloat(e[3]),0,100),a:!1}):(e=B.hsva.exec(F))?b({h:c(parseFloat(e[1]),0,360),s:c(parseFloat(e[2]),0,100),b:c(parseFloat(e[3]),0,100),a:c(parseFloat(e[4]),0,1)}):(e=B.hex8.exec(F))?{r:parseInt(e[1],16),g:parseInt(e[2],16),b:parseInt(e[3],16),a:parseInt(e[4],16)/255}:(e=B.hex6.exec(F))?{r:parseInt(e[1],16),g:parseInt(e[2],16),b:parseInt(e[3],16),a:!1}:(e=B.hex3.exec(F))?{r:parseInt(e[1]+""+e[1],16),g:parseInt(e[2]+""+e[2],16),b:parseInt(e[3]+""+e[3],16),a:!1}:!!(e=B.hex4.exec(F))&&{r:parseInt(e[1]+""+e[1],16),g:parseInt(e[2]+""+e[2],16),b:parseInt(e[3]+""+e[3],16),a:parseInt(e[4]+""+e[4],16)/255}}function h(F){return!(!F||isNaN(F.r)||isNaN(F.g)||isNaN(F.b))&&(isNaN(F.a)&&(F.a=!1),{r:Math.round(c(F.r,0,255)),g:Math.round(c(F.g,0,255)),b:Math.round(c(F.b,0,255)),a:F.a?d(c(F.a,0,1),3):F.a})}function y(e,r){if(void 0===r&&(r=0),"string"!==F.type(e))return!1;if(3===(e=(e=e.toUpperCase()).replace(/[^0-9A-F]/g,"")).length||4===e.length){for(var a="",o=1;o===e.length;o++)a=a+e[o]+e[o];e=a}return 6===e.length&&8===r&&(e+="FF"),8===e.length&&6===r&&(e=e.substring(0,6)),8===e.length&&8!==r&&"FF"==e.slice(-2)&&(e=e.substring(0,6)),(8===e.length||6===e.length)&&"#"+e}function D(F,e,r,a){switch(void 0===e&&(e="hex"),void 0===r&&(r=!0),void 0===a&&(a="hex"),F=h(F),!1===r&&(F.a=!1),e){case"rgb":return!1===F.a||1===F.a?"rgb("+F.r+", "+F.g+", "+F.b+")":"rgba("+F.r+", "+F.g+", "+F.b+", "+F.a+")";case"hex":return!1===r&&(F.a=!1),A(F);case"hsl":var o=function(F){var e,r,a,o;F=h(F),e=c(F.r,0,255)/255,r=c(F.g,0,255)/255,a=c(F.b,0,255)/255,"a"in F||(F.a=!1);o=!1!==F.a&&c(F.a,0,1);var l,i,t=Math.max(e,r,a),n=Math.min(e,r,a),s=(t+n)/2;if(t==n)l=i=0;else{var g=t-n;switch(i=s>.5?g/(2-t-n):g/(t+n),t){case e:l=(r-a)/g+(r<a?6:0);break;case r:l=(a-e)/g+2;break;case a:l=(e-r)/g+4}l/=6}return{h:d(360*l,1),s:d(100*i,1),l:d(100*s,1),a:o?d(o,3):o}}(F);return!1===o.a||1===o.a?"hsl("+o.h+", "+o.s+", "+o.l+")":"hsla("+o.h+", "+o.s+", "+o.l+", "+o.a+")";case"hsv":case"hsb":var l=k(F);return!1===l.a||1===l.a?"hsv("+l.h+", "+l.s+", "+l.b+")":"hsva("+l.h+", "+l.s+", "+l.b+", "+l.a+")";case"name":var i=function(F){return function(F){F=y(F);var e=y(F,8);if(!F||!e)return"";if("00"===e.slice(-2))return"transparent";return e in s?s[e]:F}(A(F,8))}(F);return"#"===i[0]?"rgb"!==a&&"hsl"!==a&&"hsv"!==a?i:D(F,a,!0):i;default:return""}}function A(e,r){if(void 0===r&&(r=0),!(e=h(e)))return"";var a;a=1===e.a||!1===e.a||6===r?"":Math.round(255*e.a).toString(16).toUpperCase(),8===r&&""===a&&(a="FF");var o=[e.r.toString(16).toUpperCase(),e.g.toString(16).toUpperCase(),e.b.toString(16).toUpperCase(),a];return F.each(o,function(F,e){1===e.length&&(o[F]="0"+e)}),"#"+o.join("")}function k(F){var e,r,a,o,l,i=c((F=h(F)).r/255,0,1),t=c(F.g/255,0,1),n=c(F.b/255,0,1),s=!1!==F.a&&c(F.a,0,1),g=Math.max(i,t,n),E=g-Math.min(i,t,n),u=function(F){return(g-F)/6/E+.5};return 0===E?e=r=0:(r=E/g,a=u(i),o=u(t),l=u(n),i===g?e=l-o:t===g?e=1/3+a-l:n===g&&(e=2/3+o-a),e<0?e+=1:e>1&&(e-=1)),{h:d(360*e,1),s:d(100*r,1),b:d(100*g,1),a:s?d(s,3):s}}function b(F){var e;F=!(!(e=F)||isNaN(e.h)||isNaN(e.s)||isNaN(e.b))&&(isNaN(e.a)&&(e.a=!1),{h:d(c(e.h,0,360),1),s:d(c(e.s,0,100),1),b:d(c(e.b,0,100),1),a:e.a?c(e.a,0,1):e.a});var r={},a=Math.round(F.h),o=Math.round(255*F.s/100),l=Math.round(255*F.b/100),i=!1!==F.a&&c(F.a,0,1);if(0===o)r.r=r.g=r.b=l;else{var t=l,n=(255-o)*l/255,s=a%60*(t-n)/60;360===a&&(a=0),a<60?(r.r=t,r.b=n,r.g=n+s):a<120?(r.g=t,r.b=n,r.r=t-s):a<180?(r.g=t,r.r=n,r.b=n+s):a<240?(r.b=t,r.r=n,r.g=t-s):a<300?(r.b=t,r.g=n,r.r=n+s):a<360?(r.r=t,r.g=n,r.b=t-s):(r.r=0,r.g=0,r.b=0)}return{r:Math.round(r.r),g:Math.round(r.g),b:Math.round(r.b),a:i?d(i,3):i}}function f(F){var e;F=!(!(e=F)||isNaN(e.h)||isNaN(e.s)||isNaN(e.l))&&(isNaN(e.a)&&(e.a=!1),{h:d(c(e.h,0,360),1),s:d(c(e.s,0,100),1),l:d(c(e.l,0,100),1),a:e.a?c(e.a,0,1):e.a});var r,a,o,l=c(F.h,0,360)/360,i=c(F.s,0,100)/100,t=c(F.l,0,100)/100,n=!1!==F.a&&c(F.a,0,1);function s(F,e,r){return r<0&&(r+=1),r>1&&(r-=1),r<1/6?F+6*(e-F)*r:r<.5?e:r<2/3?F+(e-F)*(2/3-r)*6:F}if(0===i)r=a=o=t;else{var g=t<.5?t*(1+i):t+i-t*i,E=2*t-g;r=s(E,g,l+1/3),a=s(E,g,l),o=s(E,g,l-1/3)}return{r:Math.round(255*r),g:Math.round(255*a),b:Math.round(255*o),a:n?d(n,3):n}}function m(e){return!!(e=h(e))&&(!(!1!==e.a&&e.a<.5)&&!(function(e){var r={r:(e=h(e)).r,g:e.g,b:e.b};return.2326*(r=F.map(r,function(F){return F=(F/=255)<=.03928?F/12.92:Math.pow((F+.055)/1.055,2.4)}))[0]+.6952*r[1]+.0722*r[2]}(e)>.22))}function v(F){if(F.data("colourpicker-lastChange"))return F.data("colourpicker-lastChange");if(F.closest(".colourpicker").is(".palette-limited")){var e=F.data("hex8-allowed")[0];return e=C(e),F.data("allow-alpha")||(e.a=!1),e}return{r:255,g:255,b:255,a:!!F.data("allow-alpha")&&1}}F(document).on("mousedown.colourpicker touchstart.colourpicker",function(e){F(e.target).parents().add(e.target).hasClass("colourpicker")||a()}).on("mousedown.colourpicker touchstart.colourpicker",".cp-list-col, .cp-list-col-outer",function(e){var r=F(this);r.hasClass("cp-list-col-outer")&&(r=r.find(".cp-list-col")),e.preventDefault(),l(r.closest(".colourpicker").find(".colourpicker-input"),r)}).on("mousedown.colourpicker touchstart.colourpicker",".colourpicker-grid, .colourpicker-slider, .colourpicker-alpha-slider",function(e){var r=F(this);e.preventDefault(),F(document).data("colourpicker-target",r),o(r,e,!0)}).on("mousemove.colourpicker touchmove.colourpicker",".colourpicker-panel",function(e){var r=F(document).data("colourpicker-target");r&&o(r,e)}).on("mouseup.colourpicker touchend.colourpicker",function(){F(this).removeData("colourpicker-target")}).on("mouseup.colourpicker touchend.colourpicker",".colourpicker-grid, .cp-list-col, .cp-list-col-outer",function(){var e=F(this).closest(".colourpicker").find(".colourpicker-input");e.data("colourpicker-settings").closeOnClick&&(a(),e.blur())}).on("focus.colourpicker",".colourpicker-input",function(){var e=F(this);e.data("colourpicker-initialized")&&(e.data("transparent",!1),r(e),i(F(this)))}).on("blur.colourpicker",".colourpicker-input",function(){var e=F(this);if(e.data("colourpicker-initialized")){var r=n(e.data("colour"));r||(r=v(e));var a=e.data("return-format"),o=e.data("allow-alpha");e.val(D(r,a,o,"hex"))}}).on("keydown.colourpicker",".colourpicker-input",function(e){var r=F(this);if(r.data("colourpicker-initialized"))switch(e.keyCode){case 9:a();break;case 13:case 27:a(),r.blur()}}).on("keyup.colourpicker",".colourpicker-input",function(){var e=F(this);e.data("colourpicker-initialized")&&i(e,!0)}).on("paste.colourpicker",".colourpicker-input",function(){var e=F(this);e.data("colourpicker-initialized")&&setTimeout(function(){i(e,!0)},1)}).on("change.colourpicker-istransparent",".input-group-addon",function(e){var r=F(this).siblings(".colourpicker-input"),o=F(this).find(".colourpicker-istransparent");a(),r.data("transparent",o.is(":checked")),i(r)})});
